#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include <avr/io.h>

#include "main_control.h"
#include "protocols/ecmd/ecmd-base.h"
#include "services/aquabox/debug_calling.h"
#include "services/MCA25/mca25.h"


int16_t parse_cmd_json(char *cmd, char *output, uint16_t len)
{
  return ECMD_FINAL(snprintf_P(output, len, PSTR(">%s<"),cmd));
}


int16_t parse_cmd_start_debug(char *cmd, char *output, uint16_t len)
{
    start_debug();
    return ECMD_FINAL_OK;
}


int16_t parse_cmd_stop_debug(char *cmd, char *output, uint16_t len)
{
    stop_debug();
    return ECMD_FINAL_OK;
}


int16_t parse_cmd_imca(char *cmd, char *output, uint16_t len)
{

    if ((mca25_stat.init = mca25_init()) == 0) mca25_stat.init = mca25_configure();
    if (mca25_stat.init)
       return ECMD_FINAL(snprintf_P(output, len, PSTR("FAIL (RET=%d)"),mca25_stat.init));
    else
       return ECMD_FINAL_OK;
}


int16_t parse_cmd_servo(char *cmd, char *output, uint16_t len)
{
  while (*cmd == ' ')
    cmd++;

  if (*cmd == '\0')
    return ECMD_FINAL(snprintf_P(output, len, PSTR("%u"), OCR1B));
  else {
    uint32_t newpos = strtoul(cmd, NULL, 10);
    OCR1B = (uint16_t) newpos;
    return ECMD_FINAL_OK;
  }
}


/*
  -- Ethersex META --
  block([[Test_ECMD_Modul]])
  ecmd_feature(json, "json",, Test ECMD-Modul.)
  ecmd_feature(start_debug, "start debug",,Starts debugging.)
  ecmd_feature(stop_debug, "stop debug",,Stops debugging.)
  ecmd_feature(imca, "imca",,Inits mca25-camera.)
  ecmd_feature(servo, "servo",,set/show Servo impuls length.)
*/

