/*
 * Copyright (c) 2009 by Stefan Siegl <stesie@brokenpipe.de>
 *               2012 Volker Klautsch <derklautsch@web.de>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (either version 2 or
 * version 3) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * For more information on the GPL, please go to:
 * http://www.gnu.org/copyleft/gpl.html
 */

#include "config.h"
#include "httpd.h"
#include "services/MCA25/mca25.h"


static void
httpd_handle_mca25_send_header (void)
{
    PASTE_RESET ();
    PASTE_P (httpd_header_200);

    PASTE_PF (PSTR ("Cache-Control: no-cache, must-revalidate\n" \
                    "Expires: Sat, 26 Jul 1997 05:00:00 GMT\n" \
                    "Content-Type: image/jpeg\n\n"));
    PASTE_SEND ();
    return;
}


void
httpd_handle_mca25_send_body (void)
{
   static unsigned int len=0;
   static char ret=1;

   if (mca25_stat.first_data) {
      if (mca25_stat.busy) {
         ret = 1;
         mca25_stat.busy = 0;
         uip_close();
         return;
      }
      mca25_stat.busy=1;
      mca25_copy_data(mca25_buf,&len);
      uip_send(mca25_buf, len);
      return;
  }

  if (uip_rexmit()) {
     uip_send(mca25_buf,len);
     return;
  }

  if (uip_acked()) {
     if (ret) { 
        ret=mca25_copy_data(mca25_buf,&len);
        uip_send(mca25_buf,len);
        return;  
     }
     ret=1;
     mca25_stat.busy=0;
     uip_close(); 
     return; 
  }
   
  if((uip_aborted() || uip_timedout()) && mca25_stat.busy) {
     while (mca25_copy_data(mca25_buf,&len)); 
     mca25_stat.busy=0;
     ret=1;
     return;
  }

#if 0
    vfs_fseek (STATE->u.vfs.fd, STATE->u.vfs.acked, SEEK_SET);
    vfs_size_t len = vfs_read (STATE->u.vfs.fd, uip_appdata, uip_mss ());

    if (len <= 0) {
	uip_abort ();
	httpd_cleanup ();
	return;
    }

    if (len < uip_mss ())	/* Short read -> EOF */
	STATE->eof = 1;

    STATE->u.vfs.sent = STATE->u.vfs.acked + len;
    uip_send (uip_appdata, len);
#endif
}


void
httpd_handle_mca25 (void)
{
    if (mca25_stat.init) {
       httpd_cleanup ();
       uip_abort ();
       return;
    }
    if (uip_acked ()) {
	if (!STATE->header_acked)
	   // STATE->u.vfs.acked = STATE->u.vfs.sent;
	   //else {
	    STATE->header_acked = 1;
	    //STATE->u.vfs.acked = 0;
	//}
    }

    if (!STATE->header_acked)
	httpd_handle_mca25_send_header ();

    //else if (STATE->eof && !uip_rexmit())
	//uip_close ();

    else
	httpd_handle_mca25_send_body ();
}

